
/*
 * Chiedere all'utente di inserire un dato numero N di interi positivi 
 * (controllando che N sia positivo e anche ogni dato in input) e 
 * determinare il massimo dei valori inseriti.
 * Variante con il calcolo anche del minimo e della media.
 * Inoltre indicare anche il numero di occorrenze del minimo e del massimo.
*/

import java.util.*;
import java.text.*;

public class MassimoDiNEsteso {
	public static void main(String[] args){
		
		Scanner tastiera = new Scanner(System.in);
		DecimalFormat df = new DecimalFormat("0.00"); // per stampare la media con due decimali
		
		int n, valore; 
		int somma=0, massimo=0, minimo=Integer.MAX_VALUE; /* Integer.MAX_VALUE  un valore costante definito nella
									classe Integer e corrisponde al massimo numero 
									intero rappresentabile sul calcolatore.
									Similmente, abbiamo visto Math.PI come la costante
									pi greco definita nella classe Math. 
									Il valore di Integer.MAX_VALUE serve per inizializzare
									minimo ad un valore molto alto, cos da consentire
									al primo numero di essere minore di tale minimo e 
									di diventare il minimo corrente. */

		int numMassimo=0, numMinimo=0; // numero di occorrenze del minimo e del massimo
		
		System.out.println("Programma per il calcolo del massimo, del minimo e della media di n interi positivi.");
		System.out.println("Per i valori di massimo e minimo si riporta anche il numero di occorrenze.");
		do{
			System.out.print("Quanti valori vuoi inserire? ");
			n = tastiera.nextInt();
			if(n<=0)
				System.out.println("Il numero di valori da inserire deve essere positivo. Riprova.");
		}while(n<=0);
		for(int i=1; i<=n; i++){
			do{
				System.out.print("Inserire il valore "+ i +": ");
				valore = tastiera.nextInt();
				if(valore <= 0)
					System.out.println("Valore errato. Inserire un valore positivo.");
			}while(valore <= 0);
			somma += valore;
			if(valore == massimo)
				numMassimo++;
			if (valore == minimo)
				numMinimo++;
			if (valore > massimo){
				massimo = valore;
				numMassimo = 1; // il numero di occorrenze deve essere reimpostato per il nuovo massimo
			}
			if (valore < minimo){
				minimo = valore;
				numMinimo = 1; // il numero di occorrenze deve essere reimpostato per il nuovo minimo
			}
		}
		System.out.print("Il valore maggiore fra quelli inseriti e': "+massimo+" che compare "+numMassimo);
		if(numMassimo > 1)
			System.out.println(" volte.");
		else
			System.out.println(" volta.");
		System.out.print("Il valore minore fra quelli inseriti e': "+minimo+" che compare "+numMinimo);
		if(numMinimo > 1)
			System.out.println(" volte.");
		else
			System.out.println(" volta.");
		System.out.println("Il valore medio fra quelli inseriti e': "+df.format((double)somma/n)); /* il cast a double di somma 
											serve per poter eseguire una divisione con
											risultato reale. Diversamente, il risultato sarebbe
											un quoziente (valore intero) */
		tastiera.close();
	}
}
